	ORG $1001-2
	DW $1001
	
astack	= $E0
xstack	= $E1
ystack	= $E2

voldown_tab	= $C2
;                
logo_cleared	= $C4
shutdown	= $C5
timer		= $C6
text_count	= $C7
legion_fadecol	= $C8
legion_fadeptr	= $C9
legion_colptr	= $CA
legion_letter	= $CB
legion_ptr	= $CC
anim_ptr	= $CE

dest_ptr	= $D0
src_ptr		= $D2
src_ptr2	= $D4
wipe_ptr	= $D6

lines		= $D8
sinus2		= $D9
plas_cnt	= $DA
status		= $DB
line_a		= $DC

; constants
max_letters	= $20
colors_plasma	= $0700
plasma_code	= $D600
timer_pos	= $0FD2
numbers		= $2D		; offset in logo charset
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	
start	SEI
	STA $FF3F
	;
	LDY #$00
	;
	LDA $FF07
	AND #$40
	BEQ pal
	;
	LDA #$F7
	STA ntsc1+1 
	LDA #60
	STA ntsc2+1
	;
	; NTSC ( 3), 62, 128, 193
	;
	LDA #06		; ensure on screen
	STA ntsc3+1
	;LDA #128
	;STA ntsc5+1
	LDA #193
	STA ntsc6+1
	STA ntsc7+1
	;
pal
ntsc1	LDA #$FF
isync	CMP $FF1D
	BNE isync
	;
	STY $FF19
	STY $FF06
	STY $FF12
	STY $FF15
	;
;	; ---
;	LDX #$10	; save zero page stuff
;ic1	LDA $10,x
;	STA $D000,x
;	LDA $110,x	; and page $100...
;	STA $D100,x
;	LDA $210,x	; and page $200...
;	STA $D200,x
;	INX
;	BNE ic1
;	; ---
	;
	LDA #font >> 8
	STA $FF13 
	;
	LDA #$08
	STA $FF14
	;
	ASL a		; A=$10, all three irq's low byte is $10 ($0010, $0110, $0210)
	STA $FFFE
	;
	LDA $FF07
	AND #$40
	ORA #$88
	STA $FF07
	;
	STY sinus2
	STY status
	STY legion_letter
	STY text_count
	STY timer    
	STY shutdown
	STY logo_cleared
	;
	TYA        
clear1	STA colors_plasma,y
	STA $0800,y
	STA $0900,y
	STA $0A00,y
	STA $0B00,y
	STA $0D00,y
	STA $0E00,y
	STA $0F00,y
	INY
	BNE clear1
	;
logoc1	LDA logo_charmap+16,y		; drop $80 bit (flag for fade)
	AND #$7F
	STA $0C00,y
	;
	LDA logo_charmap+16+1*72,y
	AND #$7F
	STA $0C00+1*40,y
	;
	LDA logo_charmap+16+2*72,y
	AND #$7F
	STA $0C00+2*40,y
	;
	LDA logo_charmap+16+3*72,y
	AND #$7F
	STA $0C00+3*40,y
	;
	LDA logo_charmap+16+4*72,y
	AND #$7F
	STA $0C00+4*40,y
	;
	LDA logo_charmap+16+5*72,y
	AND #$7F
	STA $0C00+5*40,y
	;
	LDA logo_charmap+16+6*72,y
	AND #$7F
	STA $0C00+6*40,y
	;
	INY
	CPY #40
	BNE logoc1
	;
	; -----------------
	;
	LDX #numbers+1	; write time onto screen
	STX timer_pos	; PAL: 1:22     
	;
	LDA $FF07	; NTSC: 1:08
	AND #$40
	BEQ pal_set
	;
	DEX
	STX timer_pos+2
	LDX #numbers+8
	BNE set_last	; always jump 
	;
pal_set	
	INX
	STX timer_pos+2
	;
set_last
	STX timer_pos+3   
	LDX #numbers+10
	STX timer_pos+1
	;
	; --------------------
	;
	LDX #$04
irqc1	LDA irq_null,x		; copy irq to $0110 area
	STA $0110,x
	;
	LDA #$21
	STA timer_pos - $0400,x
	;
	DEX
	BPL irqc1
	;
	LDX #irq_digi_end - irq_digi
irqc2	LDA irq_digi,x
	STA $10,x
	DEX
	BPL irqc2
	;
	LDX #irq_digi_nextbyte_end - irq_digi_nextbyte
irqc3	LDA irq_digi_nextbyte,x
	STA $0210,x
	DEX
	BPL irqc3
	;
	; --------------------
	;
	JSR PLAYER_INIT
	;
	LDA #voldown_table & 255
	STA voldown_tab 
	LDA #voldown_table >> 8
	STA voldown_tab+1 
	;
	JSR digi_init
	;
	; --------------------
	;
	LDA #color_tables & 255
	LDX #color_tables >> 8
	JSR shuffle
	;
	LDA #char_tables & 255
	LDX #char_tables >> 8
	JSR shuffle
	;
	LDA #wipes & 255
	LDX #wipes >> 8
	JSR shuffle
	;
	LDY #$08
	LDA #(text_ptrs+2) & 255
	LDX #(text_ptrs+2) >> 8 
	JSR shuffle_setmax
	;
	LDY #$06
	LDA #legion_wipe_ptrs & 255
	LDX #legion_wipe_ptrs >> 8
	JSR shuffle_setmax
	;
	; ----------------------
	;
	LDA #mytext & 255
	STA src_ptr
	LDA #mytext >> 8
	STA src_ptr+1
	;
	;LDA #$20
	;STA sin2+1
	;
	; --------------------
	; code generation
	;
	LDA #plasma_code & 255
	STA dest_ptr
	LDA #plasma_code >> 8
	STA dest_ptr+1
	; 
	LDA #$04		; line counter
	STA lines
	;
cg3	LDA #$00		; reset sin low byte for each line
	STA pc_sin+1   
	;
	LDX #39
	;
cg2	LDY #plasma_core_end-plasma_core
cg1	LDA plasma_core,y
	STA (dest_ptr),y 
	DEY
	BPL cg1
	;
	INC pc_sin+1		; next sin byte
	;
	LDA pc_dest+1
	CLC
	ADC #$01
	STA pc_dest+1
	BCC *+5
	INC pc_dest+2
	;
	LDA dest_ptr
	CLC
	ADC #plasma_core_end-plasma_core
	STA dest_ptr
	BCC *+4
	INC dest_ptr+1
	;
	DEX
	BPL cg2	
	;
	; -
	;
	LDA pc_dest+1	; skip a line
	CLC
	ADC #$28
	STA pc_dest+1
	BCC *+5
	INC pc_dest+2 
	;
	; --- 
	;
	LDA lines    
	BEQ last_line
	CMP #$04
	BEQ last_line
	;
	LDA #$C8		; INY opcode
	DB $2C
last_line
	LDA #$60		; RTS opcode
	LDY #$00
	STA (dest_ptr),y 
	;
	LDA dest_ptr
	CLC
	ADC #$01
	STA dest_ptr
	BCC *+4
	INC dest_ptr+1
	;
	DEC lines
	BPL cg3
	;
	; --------------------
	;
	JSR init_anim
	;
	; --------------------
	;    
	JSR digi_stop
	;
	LDA #$CC
isync2	CMP $FF1D
	BNE isync2
	;   
	LDA #$1B
	STA $FF06
	;
	JMP mainloop

shuffle_setmax
	STY maxrnd+1
	;		
shuffle
	STA src_ptr
	STX src_ptr+1
	;
	LDX #$00
	;
sh_loop	JSR random
	TAY
	STY ysv1+1
	;
	LDA (src_ptr),y
	PHA
	INY
	LDA (src_ptr),y
	PHA  
	JSR random
	TAY
	INY            
	LDA (src_ptr),y
	STA asv1+1
	PLA
	STA (src_ptr),y
	DEY
	LDA (src_ptr),y
	STA asv2+1
	PLA
	STA (src_ptr),y
	;
ysv1	LDY #$00
asv2	LDA #$00
	STA (src_ptr),y
	INY
asv1	LDA #$00
	STA (src_ptr),y
	;
	INX
	CPX #10
	BNE sh_loop
	RTS
	
random	LDA $FF00
rnd1	ADC #$07
	EOR $FF1D
	AND #$0F
maxrnd	CMP #10			; self-mod
	BCS rnd1
	ASL a
	RTS
	;
status_jump_table_lo
	DB prepare_letters & 255
	DB draw_letters & 255
	DB legion_prepare & 255
	DB do_nothing & 255
	DB prepare_plasma & 255
	DB plasma & 255
	;
	DB do_nothing & 255
	                        
status_jump_table_hi
	DB prepare_letters >> 8
	DB draw_letters >> 8
	DB legion_prepare >> 8
	DB do_nothing >> 8
	DB prepare_plasma >> 8
	DB plasma >> 8    
	;
	DB do_nothing >> 8
	
status_jump_table2_lo
	DB do_nothing & 255
	DB draw_letters2 & 255
	DB do_nothing & 255
	DB legion_wipe & 255
	DB do_nothing & 255
	DB plasma2 & 255  
	;
	DB vol_down & 255 
	                        
status_jump_table2_hi
	DB do_nothing >> 8
	DB draw_letters2 >> 8
	DB do_nothing >> 8
	DB legion_wipe >> 8
	DB do_nothing >> 8
	DB plasma2 >> 8   
	;
	DB vol_down >> 8
	
do_timer
	INC timer
	LDA timer
ntsc2	CMP #50
	BNE tmr1
	;
	LDX #$04
tmr4	DEX
	LDA timer_pos,x
	CMP #numbers+10
	BEQ tmr4
	CMP #numbers
	BNE tmr2
	;
	LDA timer_max,x
	STA timer_pos,x
	BNE tmr4
	;
tmr2	DEC timer_pos,x
	;
	LDA #$00
	STA timer
	;
tmr1	RTS

timer_max
	DB numbers+9, numbers+9, numbers+5, numbers+9
	
space_check
	LDA #$7F		; space check
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10
	BNE no_space
	;
	; --- space is pressed
	;
	LDA #$01
	STA shutdown  
	;         
no_space
	RTS 
	;
	; ---
	;
digi_stop
	SEI
	;
	LDA #$A2
	STA $FF0A
	;
	LDA #$00
	STA $FF0B
	;
	LDA #$01		; irq_null (relocated address!)
	STA $FFFF
	;
	CLI
	;
	RTS
	;
	; --- volume down
	;
vol_down
	INC dont_allow_digi_start+1 	; disable digi start command
	;
	LDA $FFFF
	CMP #$01			; wait until current digi note stops
	BNE ve
	;
	LDA #$A5			; LDA $00 opcode
	STA digi_note_length		; stop digi completely
	;  
	LDX vd_slow+1
	INX
	CPX #$03
	BNE *+4
	LDX #$00
	STX vd_slow+1
	;
vd_slow	LDA #$00			; slow down to 3 frames
	BNE ve
	;
	LDA voldown_tab			; go through voldown table
	CLC
	ADC #$09			; 9 bytes at a time
	STA voldown_tab
	BCC *+4
	INC voldown_tab+1
	;              
	LDA voldown_tab
	CMP #voldown_table_end & 255
	BEQ final_jump
	;
ve	RTS
	;
final_jump
	;
	LDX #$00
	TAX
fj1	STA $0F00,x
	INX
	BNE fj1
	;
;	; ---
;	LDX #$10	; restore zero page stuff
;ic2	LDA $D000,x
;	STA $10,x         
;	LDA $D100,x	; and page $100...
;	STA $110,x
;	LDA $D200,x	; and page $200...
;	STA $210,x
;	INX
;	BNE ic2
;	; ---
	;
	SEI
	LDA $FCFD
	CMP #$4C
	BEQ do_final_jump
	JMP $FFF6
do_final_jump
	JMP $FCFD
	
	;
	include "digiplay.asm"
	include "digimusic.asm"
	include "!player.asm"
	include "music.asm"
	;
	
	; PAL  (40), 62, 140, 218
	; NTSC ( 3), 62, 128, 193
	
mainloop
ntsc3	LDA #39		; $27 296-256 -> (40)
sync0	CMP $FF1D
	BCS sync0
	;
	JSR do_timer
	;
	JSR space_check
	;
	;LDA #$44
	;STA $FF19
	;
	JSR PLAYER
	;
call_anim
	BIT do_anim	; initially disabled
	;
	;LDA #$00
	;STA $FF19
	;        
	LDA #62		; $4E-16
sync1	CMP $FF1D
	BCS sync1
	;        
	LDA #font >> 8
	STA $FF13
	;
	;DEC $FF19
	JSR PLAYER_SOUND
	;INC $FF19
	;
ntsc5	LDA #140	; $9C-16
sync2	CMP $FF1D
	BCS sync2
	;
	LDA #logo >> 8
	STA $FF13
	;
	;DEC $FF15
	JSR PLAYER_SOUND
	;INC $FF15
	;        
	; ------------
	;
	;DEC $FF19
	;
	LDX status
	LDA status_jump_table_lo,x
	STA do_call+1
	LDA status_jump_table_hi,x
	STA do_call+2
	;                      
do_call	JSR draw_letters	; self-mod
	;
	;INC $FF19
	;
ntsc6	LDA #218	; $EA-16
sync3	CMP $FF1D
	BCS sync3
	;
	;DEC $FF19
	JSR PLAYER_SOUND
	;INC $FF19
	;        
	; ------------
	;
	;DEC $FF19
	;
	LDX status
	LDA status_jump_table2_lo,x
	STA do_call2+1
	LDA status_jump_table2_hi,x
	STA do_call2+2
	;
do_call2
	JSR do_nothing		; self-mod
	;
	;INC $FF19
	;
	LDA $FF1D
ntsc7	CMP #218		; $EA-16
	BCC skip_sync4
	;
	LDA #$08
sync4	CMP $FF1D
	BCC sync4
	;
	; --------------
	;
skip_sync4
	JMP mainloop
	
do_anim
	LDA anim_ptr		; only progress when pointer is on 8 byte boundary
	AND #$07
	BEQ no_anim_skip
	JMP anim_skip
	;               
no_anim_skip
	LDY #$5*8-1
;animl1	
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	DEY
	LDA (anim_ptr),y
	STA logo+8,y
	;DEY
	
	;BPL animl1
	;
anim_skip
	LDA anim_ptr
	CLC
	ADC #$04		; inc by 4
	STA anim_ptr
	BCC *+4
	INC anim_ptr+1
	;
	LDA anim_ptr
	CMP #logo_anim_end & 255
	BNE anim_e
	LDA anim_ptr+1
	CMP #logo_anim_end >> 8
	BNE anim_e
	;
init_anim
	LDA #logo_anim & 255
	STA anim_ptr
	LDA #logo_anim >> 8
	STA anim_ptr+1
	;
anim_e	RTS
	;
	; #############################################
	;
legion_prepare
	LDA shutdown
	BEQ lp1
	;
	LDA #9			; force final stage
	STA legion_letter
	;
lp1	LDA #$00
	STA legion_colptr
	STA legion_fadeptr
	;
	LDA legion_letter
	ASL a
	TAX
	;
	LDA legion_wipe_ptrs,x
	STA legion_color_ptr+1 
	LDA legion_wipe_ptrs+1,x
	STA legion_color_ptr+2 
	;
 	;LDA legion_ptrs,x
 	LDA legion_wipe_ptrs,x
 	CLC
 	ADC #$4A		; length of color data
	STA legion_ptr
	;LDA legion_ptrs+1,x
	LDA legion_wipe_ptrs+1,x
	ADC #$00
	STA legion_ptr+1
	;
	INC legion_letter
	;
	LDA legion_letter
	CMP #10
	BNE lp2
	;
	INC logo_cleared
	;
lp2	INC status
	;
	RTS
	;
	; #############################################
	;
legion_wipe
	;
	LDA legion_letter
	CMP #10
	BNE not_final_wipe
	;
	LDX legion_fadeptr
	CPX #$29
	BCC lf4
	;
	TXA
	SEC
	SBC #$29
	STA lf_end+1
	;
lf4	LDY #$07
lf2	;          
	CPY legion_fadeptr
	BCS lf3
	;
	LDA $0800+0*40-05,x
	SEC
	SBC #$10
	BPL sk1
	LDA #$00
sk1	STA $0800+0*40-05,x
	;
	LDA $0800+1*40-06,x
	SEC
	SBC #$10
	BPL sk2
	LDA #$00
sk2	STA $0800+1*40-06,x
	;
	LDA $0800+2*40-07,x
	SEC
	SBC #$10
	BPL sk3
	LDA #$00
sk3	STA $0800+2*40-07,x
	;
	LDA $0800+3*40-08,x
	SEC
	SBC #$10
	BPL sk4
	LDA #$00
sk4	STA $0800+3*40-08,x
	;
	LDA $0800+4*40-09,x
	SEC
	SBC #$10
	BPL sk5
	LDA #$00
sk5	STA $0800+4*40-09,x
	;
	LDA $0800+5*40-10,x
	SEC
	SBC #$10
	BPL sk6
	LDA #$00
sk6	STA $0800+5*40-10,x
	;
	LDA $0800+6*40-11,x
	SEC
	SBC #$10
	BPL sk7
	LDA #$00
sk7	STA $0800+6*40-11,x
	;
	;LDA legion_final_fade_colors,y
	;STA $0800+0*40-05,x
	;STA $0800+1*40-06,x
	;STA $0800+2*40-07,x
	;STA $0800+3*40-08,x
	;STA $0800+4*40-09,x
	;STA $0800+5*40-10,x
	;STA $0800+6*40-11,x
	;
lf3	INX
	DEY
lf_end	CPY #$FF
	BNE lf2
	;
	INC legion_fadeptr
	LDA legion_fadeptr
	CMP #$30
	BEQ legion_wipe_end
	;
	RTS
	;                 
not_final_wipe
	CMP #07
	BCS do_logo_wipe
	;     
	; --- wipe letters
	;
	LDX legion_colptr
	LDY #$00
lw1	LDA (legion_ptr),y
	INY
	STA dest_ptr		; low byte
	;	
	LDA (legion_ptr),y
	INY
	EOR #$04
	STA dest_ptr+1
	;
	CMP #$04
	BEQ lw2
	;
	STY ysv2+1
	;
	LDY #$00
legion_color_ptr
	LDA legion_col1,x	; self-mod
	INX
	STA (dest_ptr),y
	;
ysv2	LDY #$00
	BNE lw1
	;
lw2	INC legion_colptr
	LDA legion_colptr
	CMP #legion_col1_end - legion_col1
	BNE lw3
	;
	TYA
	CLC
	ADC legion_ptr
	STA legion_ptr
	BCC *+4
	INC legion_ptr+1
	;
legion_wipe_end
	LDA shutdown		; exception:
	BEQ lwe1		; if we just finished wipe
	;
	CMP #$02
	BEQ start_vol_down1
	;
	LDA legion_letter	; and shutdown is started
	CMP #10			; and not final wipe
	BEQ lwe1
	;
	DEC status		; then go back one status and do another wipe
	RTS
	;
lwe1	
	INC status
lw3	RTS
	;
start_vol_down1
	JMP start_vol_down
	;     
do_logo_wipe
	SEC
	SBC #$07
	;
	ASL a
	TAX 
	LDA legion_fade_colors_ptrs,x
	STA legion_fade_colors_ptr+1 
	LDA legion_fade_colors_ptrs+1,x
	STA legion_fade_colors_ptr+2 
	;
	LDX legion_fadeptr
	LDY #$07
lf1	;
legion_fade_colors_ptr
	LDA legion_fade_colors,y
	STA legion_fadecol
	;
	LDA logo_charmap,x
	BMI skip1
	LDA legion_fadecol
	STA $0800+0*40-16,x
skip1	LDA logo_charmap+1*71,x
	BMI skip2               
	LDA legion_fadecol
	STA $0800+1*40-17,x
skip2	LDA logo_charmap+2*71,x
	BMI skip3               
	LDA legion_fadecol
	STA $0800+2*40-18,x
skip3	LDA logo_charmap+3*71,x
	BMI skip4               
	LDA legion_fadecol
	STA $0800+3*40-19,x
skip4	LDA logo_charmap+4*71,x
	BMI skip5               
	LDA legion_fadecol
	STA $0800+4*40-20,x
skip5	LDA logo_charmap+5*71,x
	BMI skip6               
	LDA legion_fadecol
	STA $0800+5*40-21,x
skip6	LDA logo_charmap+6*71,x
	BMI skip7               
	LDA legion_fadecol
	STA $0800+6*40-22,x
skip7	;
	INX
	DEY
	BPL lf1
	;
	INC legion_fadeptr
	LDA legion_fadeptr
	CMP #$40
legion_wipe_end1
	BNE not_legion_wipe_end
	;
	LDA #$11		; make "csabo" text visible
	STA $082F
	STA $082F+40
	STA $082F+80
	;
	JMP legion_wipe_end
	;
not_legion_wipe_end
	RTS
	;
	; ################################
	;
prepare_letters
	LDA shutdown
	BEQ not_done
	;
	LDA logo_cleared
	BNE start_vol_down
	;
	; exception: logo not yet cleared
	;
	LDA #$02    
	STA shutdown		; mark text cleared
	DB $2C
	;
start_vol_down
	LDA #$06		; force status to volume down
	STA status
	;
	RTS
	;
not_done
	LDX #max_letters*2
	LDA #$00
prel1	STA dest_ptrs,x
	DEX
	BPL prel1
	;
wp1	LDA wipes
	STA wipe_ptr
wp2	LDA wipes+1
	STA wipe_ptr+1
	; 
	INC wp1+1
	INC wp1+1
	INC wp2+1
	INC wp2+1
	;
ctc	LDX #$00
	;
	LDA char_tables,x
	STA char_table_ptr+1
	LDA char_tables+1,x
	STA char_table_ptr+2
	;
	LDA color_tables,x
	STA color_table_ptr+1
	LDA color_tables+1,x
	STA color_table_ptr+2
	;
	LDA color_tables,x
	CLC
	ADC #$20
	STA plasma_fade_ptr+1
	STA plasma_fade_ptr_2+1
	LDA color_tables+1,x
	STA plasma_fade_ptr+2
	STA plasma_fade_ptr_2+2
	;
	INC ctc+1
	INC ctc+1
	;
	LDA text_count
	ASL a
	TAX
	LDA text_ptrs,x
	STA src_ptr
	LDA text_ptrs+1,x
	STA src_ptr+1
	;
	INC text_count
	LDA text_count
	CMP #11
	BNE not_text_done
	;
	JMP final_jump
	;
not_text_done
	INC status	; 0->1
	;
	RTS
	;
	; #############################################
	;
draw_letters
	LDA #$04
	LDX #$00
	JMP do_draw_letters

draw_letters2
	LDA #max_letters
	LDX #$04
	JSR do_draw_letters
	;
	LDA dest_ptrs+1
	BNE letters_not_done
	LDA dest_ptrs
	BPL letters_not_done
	;                      
	INC status	; 1->2
	;
	RTS
	;                   
letters_not_done
	JSR get_next_wipe_ptr
	;           
	LDA dest_ptrs+max_letters-1
	BEQ dl1
	STA dest_ptr+1
	LDA dest_ptrs+max_letters-2
	STA dest_ptr
	;
	LDA src_ptr		; calc next soure pointer
	CLC
	ADC dest_ptr
	STA src_ptr2
	LDA src_ptr+1
	ADC dest_ptr+1
	STA src_ptr2+1
	;
	LDA src_ptr2		; (sub $0D40)
	SEC
	SBC #$40
	STA src_ptr2
	LDA src_ptr2+1
	SBC #$0D
	STA src_ptr2+1
	;
	LDY #$00
	LDA (src_ptr2),y	; copy new char to screen
	STA (dest_ptr),y
	;
	LDA dest_ptr+1
	EOR #$04    
	STA dest_ptr+1
	;
	LDA #$00		; initial color is black
	STA (dest_ptr),y
	;
dl1	RTS
	;
get_next_wipe_ptr
	LDY #$00
	LDA (wipe_ptr),y
	STA dest_ptrs+max_letters-2
	INY
	LDA (wipe_ptr),y
	STA dest_ptrs+max_letters-1
	;
	LDA wipe_ptr
	CLC
	ADC #$02
	STA wipe_ptr
	BCC *+4
	INC wipe_ptr+1
	;
	RTS

do_draw_letters
	STA letter_loop_end+1	; parameter 1: A = when to stop loop
	;			; parameter 2: X = loop start
	LDY #$00
	;
letter_loop
	LDA dest_ptrs+1,x
	BEQ skip_letter
	STA dest_ptr+1
	LDA dest_ptrs,x
	STA dest_ptr
	;
	LDA (dest_ptr),y	; do char 'animation'
	AND #$1F        
char_table_ptr
	ORA chartab1,x		; self-mod
	STA (dest_ptr),y 
	;
	LDA dest_ptr+1
	EOR #$04
	STA dest_ptr+1
	;   
color_table_ptr
	LDA coltab1,x		; do color 'animation', self-mod
	STA (dest_ptr),y
	;
	; ---
	;
skip_letter
	LDA dest_ptrs+3,x
	STA dest_ptrs+1,x
	LDA dest_ptrs+2,x
	STA dest_ptrs,x     
	;
	INX
	INX
letter_loop_end
	CPX #max_letters	; self-mod
	BNE letter_loop
	;
	RTS
	;
	; #######################################
	;	
prepare_plasma
	LDX #$1F       
	;
plasma_fade_ptr_2
	LDA coltab1			; self-mod get the initial color from current table
	;
pp1	STA colors_plasma,x		; prepare plasma: fill it up with the initial color 
	STA colors_plasma+$20,x
	STA colors_plasma+$40,x
	STA colors_plasma+$60,x
	DEX
	BPL pp1
	;
	LDA #$78
	STA plas_cnt
	;
	LDA legion_letter
	CMP #$08
	BNE not_start_anim
	;
	LDX #$20		; JSR $0000 opcode
	STX call_anim            
	;     
not_start_anim
	INC status	; 2->3
	;
	RTS
	
	;
	; #######################################
	;
plasma
	;LDA $FF19
	;EOR #$55
	;STA $FF19
	;
	;LDA #$40
	;STA plasma_ptr+1
	;LDA #$0D-$04
	;STA plasma_ptr+2 
	;
	LDX plas_cnt	;---------------------
	DEX
	STX plas_cnt
	;
	CPX #$E0
	BNE pl10
	;
	LDA #$00
	STA status
	;
pl10	LDY #$00
pl9	
plasma_fade_ptr
	LDA coltab1,y
	STA colors_plasma,x
	INX
	INY
	CPY #$22
	BNE pl9
	;
	; -----------------------------
	;
	LDA x1+1
	CLC
	ADC #$01
	CMP #109	; wavelength
	BNE pl6
	LDA #$00
pl6	STA x1+1
	;
	LDA sinus2
	CLC
	ADC #$01
	CMP #77*2	; wavelength
	BNE pl7      
	LDA #$00	; wrap
pl7	STA sinus2
	;
	LSR a
	TAY
	;STA sin2+1
	;
	; ---
	;
;ntsc_11	LDA #5		; number of lines
;	STA lines
	;
pl4
	LDA lines
	CLC
x1	ADC #$00	; initial value
	TAX 
	;
	LDA lines
	CLC
	ADC plasma_sinus1,x
	;STA line_a+1
	STA line_a
	;
	JSR plasma_code
	;
;ntsc_12	LDY #39		; number of columns
;pl3	
;;line_a
;	LDA #$00
;sin2	ADC plasma_sinus2+00,y	; initial value
;	TAX
;	LDA colors_plasma,x
;plasma_ptr
;	STA $0800,y		; self-mod
;	;
;	DEY
;ntsc_13	BPL pl3
;	;
;	LDA plasma_ptr+1	; inc plasma_ptr by 40
;	CLC
;	ADC #80
;	STA plasma_ptr+1
;	BCC pl5
;	;
;	INC plasma_ptr+2
;pl5
;	;
;	;
;	DEC lines
;	BNE pl4
	;
	;LDA $FF19
	;EOR #$55
	;STA $FF19
	;
	RTS
	
plasma2
	LDA sinus2
	LSR a
	TAY  
	INY
	;
	JSR plasma_code + ( (plasma_core_end-plasma_core) * 40 + 1 ) * 1
	;
	RTS
	
do_nothing
	RTS
	
plasma_core
	LDA line_a
pc_sin	ADC plasma_sinus2,y
	TAX
	LDA colors_plasma,x
pc_dest	STA $0940 
plasma_core_end

voldown_table
	include "voldown\voldown_hex.asm"
voldown_table_end
	DB $AA
	
	ORG $8900
plasma_sinus1
	DB $21,$23,$26,$29,$2C,$2E,$31,$33,$36,$38,$3A,$3C,$3D,$3E,$40,$40
	DB $41,$41,$41,$41,$41,$40,$40,$3E,$3D,$3C,$3A,$38,$36,$33,$31,$2E
	DB $2C,$29,$26,$23,$21,$1E,$1B,$18,$15,$13,$10,$0E,$0B,$09,$07,$05
	DB $04,$03,$01,$01,$00,$00,$00,$00,$00,$01,$01,$03,$04,$05,$07,$09
	;
	DB $0B,$0E,$10,$13,$15,$18,$1B,$1E,$21,$23,$26,$29,$2B,$2E,$2F,$30
	DB $31,$31,$31,$30,$2F,$2E,$2B,$29,$26,$23,$21,$1E,$1B,$18,$16,$13
	DB $12,$11,$10,$10,$10,$11,$12,$13,$16,$18,$1B,$1E
	
	DB $21,$23,$26,$29,$2C,$2E,$31,$33,$36,$38,$3A,$3C,$3D,$3E,$40,$40
	DB $41,$41,$41,$41,$41,$40,$40,$3E,$3D,$3C,$3A,$38,$36,$33,$31,$2E
	DB $2C,$29,$26,$23,$21,$1E,$1B,$18,$15,$13,$10,$0E,$0B,$09,$07,$05
	
	DS 4 + 2*16 + 4*16 
	
	;ALIGN 256
plasma_sinus2
	DB $19,$1B,$1D,$1F,$21,$23,$25,$27,$28,$2A,$2B,$2D,$2E,$2F,$30,$31
	DB $31,$32,$32,$32,$32,$32,$31,$31,$30,$2F,$2E,$2D,$2C,$2A,$29,$27
	DB $26,$24,$22,$20,$1E,$1C,$1A,$18,$16,$14,$12,$10,$0E,$0C,$0B,$09
	DB $08,$06,$05,$04,$03,$02,$01,$01,$00,$00,$00,$00,$00,$01,$01,$02
	DB $03,$04,$05,$07,$08,$0A,$0B,$0D,$0F,$11,$13,$15,$17
	;
	DB $19,$1B,$1D,$1F,$21,$23,$25,$27,$28,$2A,$2B,$2D,$2E,$2F,$30,$31
	DB $31,$32,$32,$32,$32,$32,$31,$31,$30,$2F,$2E,$2D,$2C,$2A,$29,$27
	DB $26,$24,$22,$20,$1E,$1C,$1A,$18,$16,$14,$12,$10,$0E,$0C,$0B,$09
	DB $08,$06,$05
	
	DS $80
	;
	; ###################################################
	;   
	
;	ALIGN 32
;bp_pal	DW $00, $4E, $9C, $EA
;bp_ntsc	DW $0003,$004C,$009C,$00DB

	;ALIGN 256
dest_ptrs
	DS $100
	
char_tables
	DW chartab1, chartab1, chartab1, chartab5, chartab5
	DW chartab5, chartab2, chartab3, chartab3, chartab4
chartab1	
	DB $00,$20,$20,$40,$40,$40,$60,$60,$60,$60,$80,$80,$80,$80,$80,$A0
	DB $A0,$A0,$A0,$A0,$A0,$C0,$C0,$C0,$C0,$C0,$E0,$E0,$E0,$E0,$E0,$E0
chartab2
	DB $20,$20,$20,$00,$00,$00,$20,$20,$20,$40,$40,$40,$60,$60,$60,$60
	DB $80,$80,$80,$80,$A0,$A0,$A0,$A0,$C0,$C0,$C0,$C0,$E0,$E0,$E0,$E0
chartab3
	DB $00,$00,$00,$00,$20,$20,$20,$20,$40,$40,$40,$40,$60,$60,$60,$60
	DB $80,$80,$80,$80,$A0,$A0,$A0,$A0,$C0,$C0,$C0,$C0,$E0,$E0,$E0,$E0
chartab4
	DB $00,$00,$20,$20,$40,$40,$60,$60,$80,$80,$A0,$A0,$C0,$C0,$E0,$E0
	DB $E0,$C0,$A0,$80,$60,$40,$20,$00,$00,$20,$40,$60,$80,$A0,$C0,$E0
chartab5
	DB $00,$00,$00,$00,$00,$00,$00,$00,$20,$20,$20,$20,$20,$40,$40,$40
	DB $40,$60,$60,$60,$80,$80,$80,$A0,$A0,$A0,$C0,$C0,$C0,$E0,$E0,$E0
	
color_tables
	DW coltab1, coltab2, coltab3, coltab4, coltab5
	DW coltab1, coltab2, coltab3, coltab4, coltab5
	
	;ALIGN 256
coltab1
	DB $71,$71,$72,$72,$76,$76,$61,$61,$61,$61,$51,$51,$51,$41,$41,$41
	DB $41,$41,$41,$31,$31,$31,$21,$21,$21,$11,$11,$11,$01,$01,$01,$00
	;
	DB $71,$71,$72,$72,$76,$76,$61,$61,$61,$61,$51,$51,$51,$41,$41,$41
	DB $41,$41,$41,$31,$31,$31,$21,$21,$21,$11,$11,$11,$01,$01,$01,$00
	DB $00,$00
coltab2
	DB $55,$55,$65,$65,$75,$77,$71,$71,$77,$75,$65,$65,$55,$55,$55,$45
	DB $45,$45,$35,$35,$35,$25,$25,$25,$15,$15,$15,$05,$05,$05,$01,$01
	;                                                                 
	DB $55,$55,$55,$55,$55,$55,$45,$45,$45,$45,$45,$45,$35,$35,$35,$35
	DB $35,$35,$25,$25,$25,$25,$25,$25,$15,$15,$15,$05,$05,$05,$01,$00
	DB $00,$00
	;
coltab3
	DB $66,$76,$71,$71,$76,$76,$66,$66,$66,$56,$56,$56,$46,$46,$46,$36
	DB $36,$36,$26,$26,$26,$16,$16,$16,$16,$06,$06,$06,$06,$01,$01,$00
	;                                                                 
	DB $66,$66,$66,$66,$56,$56,$56,$56,$46,$46,$46,$46,$36,$36,$36,$36
	DB $26,$26,$26,$26,$16,$16,$16,$16,$06,$06,$06,$06,$01,$01,$01,$00
	DB $00,$00
	;
coltab4
	DB $71,$71,$77,$77,$67,$67,$57,$57,$59,$59,$58,$58,$48,$48,$42,$42
	DB $32,$32,$32,$32,$22,$22,$22,$22,$12,$12,$12,$12,$02,$02,$02,$02
	;
	DB $71,$71,$71,$77,$67,$67,$68,$68,$58,$58,$59,$59,$49,$49,$42,$42
	DB $32,$32,$32,$32,$22,$22,$22,$22,$12,$12,$12,$12,$02,$02,$01,$00
	DB $00,$00
	
coltab5
	DB $77,$77,$77,$77,$67,$67,$67,$67,$57,$57,$57,$57,$47,$47,$47,$47
	DB $37,$37,$37,$37,$27,$27,$27,$27,$17,$17,$17,$17,$07,$07,$07,$07
	;
	DB $77,$77,$77,$77,$67,$67,$67,$67,$57,$57,$57,$57,$47,$47,$47,$47
	DB $37,$37,$37,$37,$27,$27,$27,$27,$17,$17,$17,$17,$07,$07,$07,$07
	DB $00,$00

mytext
	cmap " ",$E0
	cmap "a",$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0,$E0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9
	cmap "$",$FA
	cmap ".",$FB
	cmap "-",$FC
	cmap "0",$EF
	cmap "3",$FD
	cmap "4",$FE
	cmap "7",$FF
	
text_ptrs
	DW t1,t2,t3,t4,t5,t6,t7,t8,t9,t10

t1	DB "dearly beloved...ladies and gentlemen..."
	DB "                                        "
	DB "welcome to this part from legion of doom"
	DB "                                        "
	DB "we are very proud to participate in this"
	DB "                                        "
	DB "   huge scene collaboration megademo.   "
	DB "                                        "
	DB "worry not... this will be short.  enjoy."

t2	DB "the princlipe in development was this - "
	DB "                                        "
	DB " keep it simple... there was to time to "
	DB "                                        "
	dB "   code anything fancier than this...   "
	DB "                                        "
	DB "  making this part meant a pause in an  "
	DB "                                        "
	DB "upcoming and already delayed production."
	
t3	DB "there was a deadline  on this project..."
	DB "                                        "
	DB "that is probably a good thing -- since i"
	DB "                                        "
	DB "was forced to finish it on time.  but my"
	DB "                                        "
	DB "other projects... i always find more de-"
	DB "                                        "
	DB "tails to work on. nothing gets finished."
	
t4	DB "flamebait from a hardcore plussy fan... "
	DB "                                        "
	DB "        only lamers write sid only demos"
	DB "                                        "
	DB "        only lamers write pal only demos"
	DB "                                        "
	DB "----------------------------------------"
	DB "                                        "
	DB "support the ted... support ntsc...      "
	
t5	DB "respects to gaia-tom-tlc-lavina-luca-svs"
	DB "                                        "
	DB "lando-nightbird-bubis-murphy-skoro-rachy"
	DB "                                        "
	DB "hifi-dcd-mc-jimy-maugli-ati-bionic-beast"
	DB "                                        "
	DB "unreal-csory-tgms-tpsh-larry-ninja-nukem"
	DB "                                        "
	DB "drdeath-sensor-bsz-crown-pigmy-tcfs-csio"
	
t6	DB "respects to james c.-bushrat-litwr-t.m.r"
	DB "                                        "
	DB "ulysses777-sidius-plus4vampire-mr.museum"
	DB "                                        "
	DB "----------------------------------------"
	DB "                                        "
	DB "visitors of plus4world  and demoscene.hu"
	DB "                                        "
	DB "and every remaining plus4 fan everywhere"
	
t7	DB "----------------------------------------"
	DB "                                        "
	DB "credits.......everything by csabo of lod"
	DB "                                        "
	DB "the music features lodplayer version two"
	DB "                                        "
	DB "       four times speed plus digi       "
	DB "                                        "
	DB "----------------------------------------"

t8	DB " this music is dedicated to tlc of cns. "
	DB "                                        "
	DB "his invaluable insight and comments have"
	DB "                                        "
	DB "helped me tremendously  along the years."
	DB "                                        "
	DB "----------------------------------------"
	DB "                                        "
	DB " also dedicated to luca and tom of lod. "
	
t9	DB "the tune you are listenning to is rather"
	DB "                                        "
	DB "special. in fact it breaks a new record."
	DB "                                        "
	DB "the digi is played at nineteen khz.     "
	DB "                                        "
	DB "- for those who know what it means...   "
	DB "                                        "
	DB "  the $FF00 value is $30 - very fast.   "
	
t10	DB "this concludes our  little presentation."
	DB "                                        "
	DB " please keep the applause to a minimum. "
	DB "                                        "
	DB "  we would like to  thank everyone for  "
	DB "                                        "
	DB "   coming out. have a safe trip home.   "
	DB "                                        "
	DB " legion of doom -- keep the plus4 alive "
	
	;ALIGN 256
wipes
	DW wipe01,wipe02,wipe03,wipe04
	DW wipe05,wipe06,wipe07,wipe08
	DW wipe09,wipe10
	
wipe01
	include "wipes/wipe01_hex.asm"
	DW $00FF
	DS max_letters*2
wipe02
	include "wipes/wipe02_hex.asm"
	DW $00FF
	DS max_letters*2
wipe03
	include "wipes/wipe03_hex.asm"
	DW $00FF
	DS max_letters*2
wipe04
	include "wipes/wipe04_hex.asm"
	DW $00FF
	DS max_letters*2
wipe05
	include "wipes/wipe05_hex.asm"
	DW $00FF
	DS max_letters*2
wipe06
	include "wipes/wipe06_hex.asm"
	DW $00FF
	DS max_letters*2
wipe07
	include "wipes/wipe07_hex.asm"
	DW $00FF
	DS max_letters*2
wipe08
	include "wipes/wipe08_hex.asm"
	DW $00FF
	DS max_letters*2
wipe09
	include "wipes/wipe09_hex.asm"
	DW $00FF
	DS max_letters*2
wipe10
	include "wipes/wipe10_hex.asm"
	DW $00FF
	DS max_letters*2
	
legion_wipe_ptrs
	DW legion_wipe1
	DW legion_wipe2
	DW legion_wipe3
	DW legion_wipe4
	DW legion_wipe5
	DW legion_wipe6
	
legion_wipe1

legion_col1
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $01,$02,$02,$12, $12,$22,$22,$32, $32,$42,$42,$52, $52,$62
legion_col1_end
	DB $62,$62,$62,$62, $62,$62,$62,$62, $62,$62
	DB $62,$62,$62,$62, $62,$62,$62,$62, $62,$62
	DB $62,$62,$62,$62, $62,$62,$62,$62, $62,$62
	DB $62,$62,$62,$62, $62,$62,$62,$62, $62,$62

	DW $0C2D,$0FFF,$0C55,$0FFF, $0C7D,$0FFF,$0CA5,$0FFF
	DW $0CD0,$0FFF,$0CCF,$0FFF, $0CCE,$0FFF,$0CCD,$0FFF
	DW $0CA4,$0FFF,$0C7C,$0FFF, $0C54,$0FFF,$0C2C,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000
	
legion_wipe2

legion_col2
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $08,$08,$18,$18, $28,$28,$38,$38, $48,$48,$58,$58, $68,$68
	;
	DB $68,$68,$68,$68, $68,$68,$68,$68, $68,$68
	DB $68,$68,$68,$68, $68,$68,$68,$68, $68,$68
	DB $68,$68,$68,$68, $68,$68,$68,$68, $68,$68
	DB $68,$68,$68,$68, $68,$68,$68,$68, $68,$68

	DW $0CAB,$0FFF,$0C84,$0FFF, $0C83,$0FFF,$0C5B,$0FFF
	DW $0CD6,$0FFF,$0CD5,$0FFF, $0CD4,$0FFF,$0CD3,$0FFF
	DW $0CD2,$0FFF,$0CAA,$0FFF, $0C82,$0FFF,$0C5A,$0FFF
	DW $0C33,$0FFF,$0C34,$0FFF, $0C35,$0FFF,$0C36,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000
	          
legion_wipe3	          

legion_col3
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $07,$07,$17,$17, $27,$27,$37,$37, $47,$47,$57,$57, $67,$67
	;
	DB $67,$67,$67,$67, $67,$67,$67,$67, $67,$67
	DB $67,$67,$67,$67, $67,$67,$67,$67, $67,$67
	DB $67,$67,$67,$67, $67,$67,$67,$67, $67,$67
	DB $67,$67,$67,$67, $67,$67,$67,$67, $67,$67

	DW $0C61,$0FFF,$0C89,$0FFF, $0CB1,$0FFF,$0CB3,$0FFF
	DW $0C8B,$0FFF,$0C8C,$0FFF, $0CB4,$0FFF,$0CDC,$0FFF
	DW $0CDB,$0FFF,$0CDA,$0FFF, $0CD9,$0FFF,$0CB0,$0FFF
	DW $0C88,$0FFF,$0C60,$0FFF, $0C38,$0FFF,$0C39,$0FFF
	DW $0C3A,$0FFF,$0C3B,$0FFF, $0C3C,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000
	
legion_wipe4

legion_col4
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $0A,$0A,$1A,$1A, $2A,$2A,$3A,$3A, $4A,$4A,$5A,$5A, $6A,$6A
	;
	DB $6A,$6A,$6A,$6A, $6A,$6A,$6A,$6A, $6A,$6A
	DB $6A,$6A,$6A,$6A, $6A,$6A,$6A,$6A, $6A,$6A
	DB $6A,$6A,$6A,$6A, $6A,$6A,$6A,$6A, $6A,$6A
	DB $6A,$6A,$6A,$6A, $6A,$6A,$6A,$6A, $6A,$6A

	DW $0C66,$0FFF,$0C8E,$0FFF, $0CB6,$0FFF,$0CDE,$0FFF
	DW $0CDF,$0FFF,$0CB7,$0FFF, $0C8F,$0FFF,$0C67,$0FFF
	DW $0C3F,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000

legion_wipe5	  

legion_col5
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $05,$05,$15,$15, $25,$25,$35,$35, $45,$45,$55,$55, $65,$65
	;
	DB $65,$65,$65,$65, $65,$65,$65,$65, $65,$65
	DB $65,$65,$65,$65, $65,$65,$65,$65, $65,$65
	DB $65,$65,$65,$65, $65,$65,$65,$65, $65,$65
	DB $65,$65,$65,$65, $65,$65,$65,$65, $65,$65

	DW $0C6C,$0FFF,$0C94,$0FFF, $0CBC,$0FFF,$0CBA,$0FFF
	DW $0C92,$0FFF,$0C6A,$0FFF, $0C42,$0FFF,$0C43,$0FFF
	DW $0C44,$0FFF,$0C6D,$0FFF, $0C95,$0FFF,$0CBD,$0FFF
	DW $0CE5,$0FFF,$0CE4,$0FFF, $0CE3,$0FFF,$0CE2,$0FFF
	DW $0CB9,$0FFF,$0C91,$0FFF, $0C69,$0FFF,$0C41,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000

legion_wipe6

legion_col6
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	DB $00,$00,$00,$00, $00,$00,$00,$00, $00,$00
	;
	DB $06,$06,$16,$16, $26,$26,$36,$36, $46,$46,$56,$56, $66,$66
	;
	DB $66,$66,$66,$66, $66,$66,$66,$66, $66,$66
	DB $66,$66,$66,$66, $66,$66,$66,$66, $66,$66
	DB $66,$66,$66,$66, $66,$66,$66,$66, $66,$66
	DB $66,$66,$66,$66, $66,$66,$66,$66, $66,$66

	DW $0CE8,$0FFF,$0CC0,$0FFF, $0C98,$0FFF,$0C70,$0FFF
	DW $0C72,$0FFF,$0C9A,$0FFF, $0CC2,$0FFF,$0CEA,$0FFF
	DW $0CEB,$0FFF,$0CC3,$0FFF, $0C9B,$0FFF,$0C73,$0FFF
	DW $0C4A,$0FFF,$0C49,$0FFF, $0C48,$0FFF,$0C47,$0FFF
	DW $0C6F,$0FFF,$0C97,$0FFF, $0C97,$0FFF,$0CBF,$0FFF
	DW $0CE7,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0FFF,$0FFF,$0FFF,$0FFF, $0FFF,$0FFF,$0FFF,$0FFF
	DW $0000
	
	; 2 8 7 A 5 6

;legion_ptrs
;	DW legion_col1,legion_col2
;	DW legion_col3,legion_col4
;	DW legion_col5,legion_col6
	
legion_fade_colors_ptrs
	DW legion_fade_colors
	DW legion_fade_colors+8
	DW legion_fade_colors+16
	
legion_fade_colors
	DB $01,$11,$21,$31,$41,$51,$61,$71
	DB $66,$56,$46,$36,$46,$56,$66,$71
	DB $65,$55,$45,$35,$45,$55,$65,$71
	;
legion_final_fade_colors
	DB $71,$61,$51,$41,$31,$21,$01,$00

	;ALIGN $0800
	ORG $B800
	include "font.asm"
	
	;ALIGN $0800
	ORG $C000
logo
	include "logo_charset.asm"
logo_charmap
	include "logo_charmap.asm"
	;DB $80,$80,$80,$80,$80,$80,$80,$80, $80,$80,$80,$80,$80,$80,$80,$80
	
	;ALIGN 256
logo_anim
	; 160*80 h
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$56,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$42,$3C,$00
	DB $00,$3C,$7E,$7E,$6A,$42,$3C,$00
	DB $00,$3C,$7E,$7E,$42,$42,$3C,$00
	DB $00,$3C,$7E,$56,$42,$42,$3C,$00
	DB $00,$3C,$7E,$42,$42,$42,$3C,$00
	DB $00,$3C,$6A,$42,$42,$42,$3C,$00
	DB $00,$3C,$42,$42,$42,$42,$3C,$00
	DB $00,$3C,$42,$42,$42,$6A,$3C,$00
	DB $00,$3C,$42,$42,$42,$7E,$3C,$00
	DB $00,$3C,$42,$42,$56,$7E,$3C,$00
	DB $00,$3C,$42,$42,$7E,$7E,$3C,$00
	DB $00,$3C,$42,$6A,$7E,$7E,$3C,$00
	DB $00,$3C,$42,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$56,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00

	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$1C,$3E,$7E,$7E,$7E,$3C,$00
	DB $00,$1C,$3E,$7E,$7E,$3E,$1C,$00
	DB $00,$1C,$3E,$7E,$7E,$3C,$18,$00
	DB $00,$18,$3C,$7E,$7E,$3C,$18,$00
	DB $00,$08,$1C,$3E,$7E,$3C,$18,$00
	DB $00,$08,$1C,$3E,$3E,$1C,$08,$00
	DB $00,$08,$1C,$3E,$3C,$18,$00,$00
	DB $00,$00,$18,$3C,$3C,$18,$00,$00
	DB $00,$00,$08,$1C,$3C,$18,$00,$00
	DB $00,$00,$08,$1C,$1C,$08,$00,$00
	DB $00,$00,$08,$1C,$18,$00,$00,$00
	DB $00,$00,$00,$18,$18,$00,$00,$00
	DB $00,$00,$00,$08,$18,$00,$00,$00
	DB $00,$00,$00,$08,$08,$00,$00,$00
	DB $00,$00,$00,$08,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$80,$C0
	DB $00,$00,$00,$00,$80,$C0,$E0,$F0
	DB $00,$00,$80,$C0,$E0,$F0,$F8,$FC

	DB $80,$C0,$E0,$F0,$F8,$FC,$FE,$FF
	DB $E0,$F0,$F8,$FC,$FE,$FF,$FF,$FF
	DB $F8,$FC,$FE,$FF,$FF,$FF,$FF,$FF
	DB $FE,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F
	DB $FF,$FF,$FF,$FF,$FF,$7F,$3F,$1F
	DB $FF,$FF,$FF,$7F,$3F,$1F,$0F,$07
	DB $FF,$7F,$3F,$1F,$0F,$07,$03,$01
	DB $3F,$1F,$0F,$07,$03,$01,$00,$00
	DB $0F,$07,$03,$01,$00,$00,$00,$00
	DB $03,$01,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$10,$00,$00,$00,$00
	DB $00,$00,$00,$10,$10,$00,$00,$00
	DB $00,$00,$00,$10,$18,$00,$00,$00
	DB $00,$00,$00,$18,$18,$00,$00,$00
	DB $00,$00,$10,$18,$18,$00,$00,$00
	DB $00,$00,$10,$38,$18,$00,$00,$00
	DB $00,$00,$10,$38,$38,$00,$00,$00
	DB $00,$00,$10,$38,$38,$10,$00,$00

	DB $00,$00,$10,$38,$38,$18,$00,$00
	DB $00,$00,$10,$38,$3C,$18,$00,$00
	DB $00,$00,$10,$3C,$3C,$18,$00,$00
	DB $00,$00,$18,$3C,$3C,$18,$00,$00
	DB $00,$10,$38,$3C,$3C,$18,$00,$00
	DB $00,$10,$38,$7C,$7C,$18,$00,$00
	DB $00,$10,$38,$7C,$7C,$38,$10,$00
	DB $00,$10,$38,$7C,$7C,$3C,$18,$00
	DB $00,$10,$38,$7E,$7E,$3C,$18,$00
	DB $00,$18,$3C,$7E,$7E,$3C,$18,$00
	DB $00,$38,$7C,$7E,$7E,$3C,$18,$00
	DB $00,$38,$7C,$7E,$7E,$7C,$38,$00
	DB $00,$38,$7C,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $3C,$7E,$7E,$7E,$7E,$3C,$00,$00
	DB $78,$FC,$FC,$FC,$FC,$78,$00,$00
	DB $00,$78,$FC,$FC,$FC,$FC,$78,$00
	DB $00,$00,$78,$FC,$FC,$FC,$FC,$78
	DB $00,$00,$3C,$7E,$7E,$7E,$7E,$3C
	DB $00,$00,$1E,$3F,$3F,$3F,$3F,$1E

	DB $00,$00,$1E,$3F,$3F,$3F,$3F,$1E
	DB $00,$1E,$3F,$3F,$3F,$3F,$1E,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$66,$66,$7E,$3C,$00
	DB $00,$3C,$66,$42,$42,$66,$3C,$00
	DB $00,$3C,$42,$42,$42,$42,$3C,$00
	DB $18,$24,$42,$81,$81,$42,$24,$18
	DB $3C,$42,$81,$81,$81,$81,$42,$3C
	DB $3C,$42,$81,$99,$99,$81,$42,$3C
	DB $3C,$42,$99,$A5,$A5,$99,$42,$3C
	DB $42,$99,$24,$42,$42,$24,$99,$42
	DB $BD,$42,$81,$81,$81,$81,$42,$BD
	DB $42,$81,$00,$00,$00,$00,$81,$42
	DB $81,$00,$00,$00,$00,$00,$00,$81
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$10,$00,$00,$00,$00
	DB $00,$00,$00,$10,$08,$00,$00,$00
	DB $00,$00,$10,$10,$08,$00,$00,$00
	DB $00,$00,$10,$10,$08,$08,$00,$00
	DB $00,$10,$10,$10,$08,$08,$00,$00

	DB $00,$10,$10,$10,$08,$08,$08,$00
	DB $10,$10,$10,$10,$08,$08,$08,$00
	DB $10,$10,$10,$10,$08,$08,$08,$08
	DB $20,$20,$10,$10,$08,$08,$04,$04
	DB $40,$20,$20,$10,$08,$04,$04,$02
	DB $80,$40,$20,$10,$08,$04,$02,$01
	DB $00,$80,$60,$10,$08,$06,$01,$00
	DB $00,$00,$C0,$30,$0C,$03,$00,$00
	DB $00,$00,$00,$F0,$0F,$00,$00,$00
	DB $00,$00,$00,$0F,$F0,$00,$00,$00
	DB $00,$00,$03,$0C,$30,$C0,$00,$00
	DB $00,$01,$06,$08,$10,$60,$80,$00
	DB $01,$02,$04,$08,$10,$20,$40,$80
	DB $02,$04,$04,$08,$10,$20,$20,$40
	DB $04,$04,$08,$08,$10,$10,$20,$20
	DB $08,$08,$08,$08,$10,$10,$10,$10
	DB $00,$08,$08,$08,$10,$10,$10,$00
	DB $00,$00,$08,$08,$10,$10,$00,$00
	DB $00,$00,$00,$08,$10,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00

	DB $00,$00,$00,$00,$00,$00,$00,$3C
	DB $00,$00,$00,$00,$00,$00,$3C,$7E
	DB $00,$00,$00,$00,$00,$3C,$7E,$7E
	DB $00,$00,$00,$00,$3C,$7E,$7E,$7E
	DB $00,$00,$00,$3C,$7E,$7E,$7E,$7E
	DB $00,$00,$3C,$7E,$7E,$7E,$7E,$3C
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $3C,$7E,$7E,$7E,$7E,$3C,$00,$00
	DB $7E,$7E,$7E,$7E,$3C,$00,$00,$00
	DB $7E,$7E,$7E,$3C,$00,$00,$00,$00
	DB $7E,$7E,$3C,$00,$00,$00,$00,$00
	DB $7E,$3C,$00,$00,$00,$00,$00,$00
	DB $3C,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$80,$80,$80,$80,$00,$00
	DB $00,$80,$C0,$C0,$C0,$C0,$80,$00
	DB $00,$C0,$E0,$E0,$E0,$E0,$C0,$00
	DB $00,$E0,$F0,$F0,$F0,$F0,$E0,$00
	DB $00,$F0,$F8,$F8,$F8,$F8,$F0,$00
	DB $00,$78,$FC,$FC,$FC,$FC,$78,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00

	DB $00,$1C,$3E,$3E,$3E,$1C,$00,$00
	DB $0E,$1F,$1F,$1F,$0E,$00,$00,$00
	DB $0F,$0F,$0F,$0F,$00,$00,$00,$00
	DB $1E,$1E,$1E,$1E,$00,$00,$00,$00
	DB $3C,$3C,$3C,$3C,$00,$00,$00,$00
	DB $78,$78,$78,$78,$00,$00,$00,$00
	DB $F0,$F0,$F0,$F0,$00,$00,$00,$00
	DB $F0,$F0,$F0,$F0,$00,$04,$00,$00
	DB $F0,$F0,$F0,$F0,$00,$04,$04,$00
	DB $F0,$F0,$F0,$F0,$00,$04,$06,$00
	DB $F0,$F0,$F0,$F0,$00,$06,$06,$00
	DB $F0,$F0,$F0,$F0,$0C,$06,$06,$00
	DB $F0,$F0,$F0,$F0,$0C,$0E,$0E,$00
	DB $F0,$F0,$F0,$F0,$0C,$0E,$0E,$0C
	DB $F0,$F0,$F0,$F0,$0C,$0E,$0E,$0F
	DB $F0,$F0,$F0,$F0,$0C,$0F,$0F,$0F
	DB $F0,$F0,$F0,$F0,$0F,$0F,$0F,$0F
	DB $00,$F0,$F0,$FF,$FF,$0F,$0F,$00
	DB $00,$00,$FF,$FF,$FF,$FF,$00,$00
	DB $00,$55,$FF,$FF,$FF,$FF,$AA,$00

	DB $00,$FF,$FF,$FF,$FF,$FF,$FF,$00
	DB $AA,$FF,$FF,$FF,$FF,$FF,$FF,$55
	DB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $FF,$FF,$FF,$EF,$FF,$FF,$FF,$FF
	DB $FF,$FF,$FF,$EF,$EF,$FF,$FF,$FF
	DB $FF,$FF,$FF,$EF,$E7,$FF,$FF,$FF
	DB $FF,$FF,$FF,$E7,$E7,$FF,$FF,$FF
	DB $FF,$FF,$CF,$E7,$E7,$FF,$FF,$FF
	DB $FF,$FF,$CF,$C7,$C7,$FF,$FF,$FF
	DB $FF,$FF,$CF,$C7,$C7,$CF,$FF,$FF
	DB $FF,$FF,$CF,$C7,$C7,$C3,$FF,$FF
	DB $FF,$FF,$CF,$C3,$C3,$C3,$FF,$FF
	DB $FF,$FF,$C3,$C3,$C3,$C3,$FF,$FF
	DB $FF,$9F,$83,$C3,$C3,$C3,$FF,$FF
	DB $FF,$9F,$83,$83,$83,$C3,$FF,$FF
	DB $FF,$9F,$83,$83,$83,$83,$9F,$FF
	DB $FF,$9F,$83,$83,$83,$83,$87,$FF
	DB $FF,$9F,$83,$83,$83,$81,$81,$FF
	DB $FF,$9F,$83,$81,$81,$81,$81,$FF
	DB $FF,$99,$81,$81,$81,$81,$81,$FF

	DB $FF,$81,$81,$81,$81,$81,$81,$FF
	DB $1E,$E2,$82,$81,$81,$41,$47,$78
	DB $0C,$34,$C2,$82,$41,$43,$2C,$30
	DB $18,$24,$42,$81,$81,$42,$24,$18
	DB $18,$24,$42,$81,$81,$42,$3C,$00
	DB $18,$24,$42,$82,$82,$42,$3C,$00
	DB $00,$3C,$42,$82,$82,$42,$3C,$00
	DB $00,$3C,$42,$42,$42,$42,$3C,$00
	DB $00,$3C,$62,$42,$42,$42,$3C,$00
	DB $00,$3C,$72,$62,$42,$42,$3C,$00
	DB $00,$3C,$7A,$72,$62,$42,$3C,$00
	DB $00,$3C,$7E,$7A,$72,$62,$3C,$00
	DB $00,$3C,$7E,$7E,$7A,$72,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7A,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
logo_anim_end
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00
	DB $00,$3C,$7E,$7E,$7E,$7E,$3C,$00

