
astack = $2E
ystack = $2F

digi_addr = $15			; this is fixed
				; self-modifying zero page code

digi_order	= $30		; digi player variables
digi_pattern	= digi_order + 2
sample_length	= digi_order + 4 ; byte for sample length
note_length	= digi_order + 5 ; byte for speed 'digi_step'
digi_step	= digi_order + 6 ; byte flag to start playing new sample

digi_init
	LDA #$FD		; SHIFT key check
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$80
	BNE no_shift
	;
	LDA WavBits_ptr+1	; use second WavBits table, digi only
	CLC
	ADC #$07
	STA WavBits_ptr+1
	;
	LDA #$A9		; ugly hack, insert LDA #$96
	STA pl_70+2
	LDA #$96
	STA pl_70+3 	      
	;     
no_shift
	;           
	LDA #$7F		; COMMODORE key check
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$20
	BNE no_commodore
	;
	INC dont_allow_digi_start+1 	; disable digi start command, music only          
	;
no_commodore
	LDY #$00
	STY digi_step
	;       
	STY digi_order
	LDA #kick_sample >> 8	; address of first sample
	STA digi_order+1
	;
dl_1	LDA (digi_order),y	; convert bytes
	TAX
WavBits_ptr
	LDA WavBits,x
	STA (digi_order),y
	INY
	BNE dl_1
	;
	INC digi_order+1
	LDA digi_order+1
	CMP #(sample_data_end >> 8)+1
	BNE dl_1
	;
	; ---
	;
digi_speed
	LDX #$30		; digi speed
	LDA $FF07
	AND #$40
	BEQ digi_pal
	;
	; *** NTSC specific
	;     swap scratch sample to scratch_ntsc sample
	;
	LDX #$00
ntsc_loop_1
	LDA xBeat-1,x
	CMP #scra
	BNE no_ntsc_swap
	;
	LDA #scra_ntsc		; new address
	STA xBeat-1,x
	INX
	LDA #14*2		; new length
	STA xBeat-1,x 
	;
no_ntsc_swap
	INX
	BNE ntsc_loop_1
	;
	LDX #$40		; digi speed for NTSC
digi_pal
	STX $FF00		; set digi speed
	STY $FF01
	;  
	; ***
	;          
	LDA #Orders & 255
	LDX #Orders >> 8
	STA digi_order
	STX digi_order + 1
	;                
	LDA (digi_order),y	; preload first pattern pointer
	STA digi_pattern
	;
	INC digi_order
	;
	LDA (digi_order),y
	STA digi_pattern + 1
	;
	INC digi_order
	;   
	LDA (digi_pattern),y	; first byte: sample address high (or zero for repeat)
	STA digi_addr+2
	STY digi_addr+1		; low byte always zero
	;
	INC digi_pattern
	;       
	LDA (digi_pattern),y	; 2nd byte: total sample length
	STA sample_length
	;
	INC digi_pattern
	;
	LDA (digi_pattern),y	; 3rd byte: note length
	STA note_length
	;
	INC digi_pattern
	;
	LDA #$FE
	STA $FF0E
	STA $FF0F
	LDA #$03
	STA $FF10
	LDA $FF12
	ORA #$03
	STA $FF12
	;
	RTS
	
digi_start
	SEI
	;
	LDA #$00		; irq_digi (relocated address!)
	STA $FFFF
	;
	LDA #$A8
	STA $FF0A
	;
	;LDA #$2C
	;STA set_vol
	;
	CLI
	;
	RTS

WavBits
	;DB $30,$31,$32,$33,$34,$35,$36
	DB $31,$32,$33,$34,$35,$36,$37
	;DB $32,$33,$34,$35,$36,$37,$38
	
	DB $91,$92,$93,$94,$95,$96,$97	; digi only (no music)
	;DB $34,$34,$34,$34,$34,$34,$34 ; music only (no digi)
	;	
	
	;
	; #####################
	;
irq_digi
	STA $29			; +00 - (3) Save A - Address is fixed to (*) below
	;   
	ASL $FF09		; +02 - (6) Acknowledge IRQ
	;
	LDA $FF11		; +05 - (4) self-mod
	STA $FF11		; (4) set Volume: play digi
	;
	INC digi_addr+1		; (5)
	BNE id_noinc		; (3) if taken
	INC digi_addr+2		;
	;
	DEC sample_length
	BNE id_noinc
	;
	INC $FFFF		; go to irq_null from now on
	;
id_noinc
	LDA #$00		; (*) (2) self-mod zero page code
	RTI			; (6) avg IRQ call: (33) cycles
irq_digi_end	
	;
	; #####################
	;
irq_null
	ASL $FF09		; Acknowledge IRQ and do nothing
	RTI
	;
	; #####################
	;
irq_digi_nextbyte
	STA astack      	; Save A, Y
	STY ystack
	;   
	ASL $FF09		; Acknowledge IRQ
	;
Read_NextByte
	LDY #$00
	STY digi_step
	STY $FFFF		; irq_digi (relocated address!) back to normal digi playing
	;
	LDA (digi_pattern),y	; first byte: sample digi_address high (or zero for repeat)
	BEQ digi_patternEnd
	;
	STA digi_addr+2
	STY digi_addr+1
	;
	INC digi_pattern
	;       
	LDA (digi_pattern),y	; 2nd byte: total sample length
	STA sample_length
	;
	INC digi_pattern
	;
	LDA (digi_pattern),y	; 3rd byte: note length
	STA note_length
	;
	INC digi_pattern
	BNE noinc_1
	INC digi_pattern+1
noinc_1
	; ----------
	;
	LDY ystack
	LDA astack
	RTI
	
Restart_order
	LDA #Orders & 255
	STA digi_order
	;
	LDA #Orders >> 8
	STA digi_order + 1
	;                
digi_patternEnd
	LDA (digi_order),y
	STA digi_pattern
	;
	INC digi_order
	;
	LDA (digi_order),y
	STA digi_pattern + 1
	;
	BEQ Restart_order
	;
	INC digi_order
	;
	JMP Read_NextByte
irq_digi_nextbyte_end
	;
	;eof